library urn;

Map _bucketMap = {};

// Resolve short path to full URL
String bucketResolve(String url, {config}) {
  config = config ?? {};

  if (url == '') return '';

  var colonPos = url.indexOf('://');

  if (colonPos == -1) {
    return url;
  }

  String protocol = url.substring(0, colonPos);

  if (protocol != '' && _bucketMap[protocol] != null) {
    return _bucketMap[protocol]['baseURL'] + '/' + url.substring(colonPos + 3);
  }

  if (_bucketMap['default']) {
    return _bucketMap['default']['baseURL'] + '/' + url;
  }

  return url;
}

// Register new path by its name
bucketRegister(name, baseURL, {config}) {
  config = config ?? {};

  _bucketMap[name] = {
    'config': config,
    'baseURL': baseURL,
  };
}
